color sentimentDetermine(int subject) {
  color c = #FFFFFF;
  if (subject == 1) {
    c = pink;
  } else if (subject == -1) {
    c = green;
  } else if (subject == 0) {
    c = blue;
  }
  return c;
}

color topicDetermine(int subject) {
  color c = #FFFFFF;
  if (subject == 0) {
    c = #ff69b4;
  } else if (subject == 1) {
    c = #ffdead;
  } else if (subject == 2) {
    c = #1e90ff;
  } else if (subject == 3) {
    c = #a020f0;
  } else if (subject == 4) {
    c = #00ffff;
  } else if (subject == 5) {
    c = #ffff00;
  } else if (subject == 6) {
    c = #ff0000;
  } else if (subject == 7) {
    c = #008000;
  } 
  return c;
}

float timeParser(String rawTime) {
  String[] times = split(rawTime, ':');
  float parsedTime = float(times[0])*60+float(times[1]);
  return parsedTime;
}

float dateParser(String rawDate) {
  String[] dates = split(rawDate, '/');
  float parsedDate = ((float(dates[0])-9)*30 + float(dates[1])-9);
  return parsedDate;
}

void SentimentGrouping (ArrayList<User> users) {
  for (int i=0; i<users.size(); i++) {
    float dateAxis = map(dateParser(users.get(i).date)-30, -30, 60, -100, 100);
    float date2Axis = map(dateParser(users.get(i).date)+30, -30, 60, -100, 100);
    float timeAxis = map(timeParser(users.get(i).time), 0, 1440, 50, -50);
    float m1Axis = map(users.get(i).m1, 3000, 0, -50, 50);
    float m2Axis =  map(users.get(i).m2, 3000, 0, -50, 50);
    color c = sentimentDetermine(users.get(i).sentiment);

    if  (showPoint == true) {
      drawPoint(dateAxis, date2Axis, timeAxis, c);
    }

    if (SHOWRED == true) {
      if (users.get(i).sentiment==1) {
        drawCurve(dateAxis, date2Axis, timeAxis, m1Axis, m2Axis, pink);
        pushMatrix();

        float t_z = timeAxis;
        float t_x = (date2Axis - dateAxis) / 2.0 + dateAxis;
        float t_y = m2Axis-m1Axis;

        translate(t_x, t_y, t_z);
        if (showMiddle == true) {
          strokeWeight(3);
          point(0, 0, 0);
          fill(pink);
        }

        float mouseObjectDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0));
        if (mouseObjectDistance < 30) {
          strokeWeight(10);
          point(0, 0, 0);
          fill(pink);

          float[] rotations = cam.getRotations();
          rotateX(rotations[0]);
          rotateY(rotations[1]);
          rotateZ(rotations[2]);

          textMode(SHAPE);
          textSize(3);
          n = users.get(i).botscore;
          s = users.get(i).m2-users.get(i).m1;
          y = users.get(i).date.toUpperCase();
          if (showDate == false) {
            if (showItem == false) {
              text(s, 0, 0);
            } else {
              text(n, 0, 0);
            }
          } else {
            text(y, 0, 0);
          }
        }
        popMatrix();
      }
    }

    if (SHOWGREEN == true) {
      if (users.get(i).sentiment==-1) {
        drawCurve(dateAxis, date2Axis, timeAxis, m1Axis, m2Axis, green);
       

        float t_z = timeAxis;
        float t_x = (date2Axis - dateAxis) / 2.0 + dateAxis;
        float t_y = m2Axis-m1Axis;

        pushMatrix();
        translate(t_x, t_y, t_z);
        if (showMiddle == true) {
          strokeWeight(3);
          point(0, 0, 0);
          fill(pink);
        }

        float mouseObjectDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0));
        if (mouseObjectDistance < 30) {
          strokeWeight(10);
          point(0, 0, 0);
          fill(green);

          float[] rotations = cam.getRotations();
          rotateX(rotations[0]);
          rotateY(rotations[1]);
          rotateZ(rotations[2]);

          textMode(SHAPE);
          textSize(3);
          n = users.get(i).botscore;
          s = users.get(i).m2-users.get(i).m1;
          y = users.get(i).date.toUpperCase();
          if (showDate == false) {
            if (showItem == false) {
              text(s, 0, 0);
            } else {
              text (n, 0, 0);
            }
          } else {
            text(y, 0, 0);
          }
        }
        popMatrix();
      }
    }

    if (SHOWNEUTRAL == true) {
      if (users.get(i).sentiment==0) {
        drawCurve(dateAxis, date2Axis, timeAxis, m1Axis, m2Axis, blue);

        float t_z = timeAxis;
        float t_x = (date2Axis - dateAxis) / 2.0 + dateAxis;
        float t_y = m2Axis-m1Axis;

        pushMatrix();
        translate(t_x, t_y, t_z);
        if (showMiddle == true) {
          strokeWeight(3);
          point(0, 0, 0);
          fill(pink);
        }

        float mouseObjectDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0));
        if (mouseObjectDistance < 30) {
          strokeWeight(10);
          point(0, 0, 0);
          fill(blue);

          float[] rotations = cam.getRotations();
          rotateX(rotations[0]);
          rotateY(rotations[1]);
          rotateZ(rotations[2]);

          textMode(SHAPE);
          textSize(3);
          n = users.get(i).botscore;
          s = users.get(i).m2-users.get(i).m1;
          y = users.get(i).date.toUpperCase();
          if (showDate == false) {
            if (showItem == false) {
              text(s, 0, 0);
            } else {
              text (n, 0, 0);
            }
          } else {
            text(y, 0, 0);
          }
        }
        popMatrix();
      }
    }
  }
}

void TopicGrouping(ArrayList<User> users) {

  for (int i=0; i<users.size(); i++) {
    float dateAxis = map(dateParser(users.get(i).date)-30, -30, 60, -100, 100);
    float date2Axis = map(dateParser(users.get(i).date)+30, -30, 60, -100, 100);
    float timeAxis = map(timeParser(users.get(i).time), 0, 1440, 50, -50);
    float m1Axis = map(users.get(i).m1, 3000, 0, -50, 50);
    float m2Axis =  map(users.get(i).m2, 3000, 0, -50, 50);
    color c = topicDetermine(users.get(i).topic);

    if (SHOWGREEN == true) {
      if (users.get(i).topic==0) {
        drawCurve(dateAxis, date2Axis, timeAxis, m1Axis, m2Axis, c);
  
                float t_z = timeAxis;
        float t_x = (date2Axis - dateAxis) / 2.0 + dateAxis;
        float t_y = m2Axis-m1Axis;

        pushMatrix();
        translate(t_x, t_y, t_z);
        if (showMiddle == true) {
          strokeWeight(3);
          point(0, 0, 0);
          fill(pink);
        }

        float mouseObjectDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0));
        if (mouseObjectDistance < 30) {
          strokeWeight(10);
          point(0, 0, 0);
          fill(blue);

          float[] rotations = cam.getRotations();
          rotateX(rotations[0]);
          rotateY(rotations[1]);
          rotateZ(rotations[2]);

          textMode(SHAPE);
          textSize(3);
          n = users.get(i).botscore;
          s = users.get(i).m2-users.get(i).m1;
          y = users.get(i).date.toUpperCase();
          if (showDate == false) {
            if (showItem == false) {
              text(s, 0, 0);
            } else {
              text (n, 0, 0);
            }
          } else {
            text(y, 0, 0);
          }
        }
        popMatrix();
      }
      }
      
      
    if (SHOWRED == true) {
      if (users.get(i).topic==1) {
        drawCurve(dateAxis, date2Axis, timeAxis, m1Axis, m2Axis, c);
                float t_z = timeAxis;
        float t_x = (date2Axis - dateAxis) / 2.0 + dateAxis;
        float t_y = m2Axis-m1Axis;

        pushMatrix();
        translate(t_x, t_y, t_z);
        if (showMiddle == true) {
          strokeWeight(3);
          point(0, 0, 0);
          fill(pink);
        }

        float mouseObjectDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0));
        if (mouseObjectDistance < 30) {
          strokeWeight(10);
          point(0, 0, 0);
          fill(blue);

          float[] rotations = cam.getRotations();
          rotateX(rotations[0]);
          rotateY(rotations[1]);
          rotateZ(rotations[2]);

          textMode(SHAPE);
          textSize(3);
          n = users.get(i).botscore;
          s = users.get(i).m2-users.get(i).m1;
          y = users.get(i).date.toUpperCase();
          if (showDate == false) {
            if (showItem == false) {
              text(s, 0, 0);
            } else {
              text (n, 0, 0);
            }
          } else {
            text(y, 0, 0);
          }
        }
        popMatrix();
      }
      }
    
    if (SHOWNEUTRAL == true) {
      if (users.get(i).topic==2) {
        drawCurve(dateAxis, date2Axis, timeAxis, m1Axis, m2Axis, c);
                float t_z = timeAxis;
        float t_x = (date2Axis - dateAxis) / 2.0 + dateAxis;
        float t_y = m2Axis-m1Axis;

        pushMatrix();
        translate(t_x, t_y, t_z);
        if (showMiddle == true) {
          strokeWeight(3);
          point(0, 0, 0);
          fill(pink);
        }

        float mouseObjectDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0));
        if (mouseObjectDistance < 30) {
          strokeWeight(10);
          point(0, 0, 0);
          fill(blue);

          float[] rotations = cam.getRotations();
          rotateX(rotations[0]);
          rotateY(rotations[1]);
          rotateZ(rotations[2]);

          textMode(SHAPE);
          textSize(3);
          n = users.get(i).botscore;
          s = users.get(i).m2-users.get(i).m1;
          y = users.get(i).date.toUpperCase();
          if (showDate == false) {
            if (showItem == false) {
              text(s, 0, 0);
            } else {
              text (n, 0, 0);
            }
          } else {
            text(y, 0, 0);
          }
        }
        popMatrix();
      }
      }
    
    if (SHOW3 == true) {
      if (users.get(i).topic==3) {
        drawCurve(dateAxis, date2Axis, timeAxis, m1Axis, m2Axis, c);
                float t_z = timeAxis;
        float t_x = (date2Axis - dateAxis) / 2.0 + dateAxis;
        float t_y = m2Axis-m1Axis;

        pushMatrix();
        translate(t_x, t_y, t_z);
        if (showMiddle == true) {
          strokeWeight(3);
          point(0, 0, 0);
          fill(pink);
        }

        float mouseObjectDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0));
        if (mouseObjectDistance < 30) {
          strokeWeight(10);
          point(0, 0, 0);
          fill(blue);

          float[] rotations = cam.getRotations();
          rotateX(rotations[0]);
          rotateY(rotations[1]);
          rotateZ(rotations[2]);

          textMode(SHAPE);
          textSize(3);
          n = users.get(i).botscore;
          s = users.get(i).m2-users.get(i).m1;
          y = users.get(i).date.toUpperCase();
          if (showDate == false) {
            if (showItem == false) {
              text(s, 0, 0);
            } else {
              text (n, 0, 0);
            }
          } else {
            text(y, 0, 0);
          }
        }
        popMatrix();
      }
      }
    
    if (SHOW4 == true) {
      if (users.get(i).topic==4) {
        drawCurve(dateAxis, date2Axis, timeAxis, m1Axis, m2Axis, c);
                float t_z = timeAxis;
        float t_x = (date2Axis - dateAxis) / 2.0 + dateAxis;
        float t_y = m2Axis-m1Axis;

        pushMatrix();
        translate(t_x, t_y, t_z);
        if (showMiddle == true) {
          strokeWeight(3);
          point(0, 0, 0);
          fill(pink);
        }

        float mouseObjectDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0));
        if (mouseObjectDistance < 30) {
          strokeWeight(10);
          point(0, 0, 0);
          fill(blue);

          float[] rotations = cam.getRotations();
          rotateX(rotations[0]);
          rotateY(rotations[1]);
          rotateZ(rotations[2]);

          textMode(SHAPE);
          textSize(3);
          n = users.get(i).botscore;
          s = users.get(i).m2-users.get(i).m1;
          y = users.get(i).date.toUpperCase();
          if (showDate == false) {
            if (showItem == false) {
              text(s, 0, 0);
            } else {
              text (n, 0, 0);
            }
          } else {
            text(y, 0, 0);
          }
        }
        popMatrix();
      }
      }
    
    if (SHOW5 == true) {
      if (users.get(i).topic==5) {
        drawCurve(dateAxis, date2Axis, timeAxis, m1Axis, m2Axis, c);
                float t_z = timeAxis;
        float t_x = (date2Axis - dateAxis) / 2.0 + dateAxis;
        float t_y = m2Axis-m1Axis;

        pushMatrix();
        translate(t_x, t_y, t_z);
        if (showMiddle == true) {
          strokeWeight(3);
          point(0, 0, 0);
          fill(pink);
        }

        float mouseObjectDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0));
        if (mouseObjectDistance < 30) {
          strokeWeight(10);
          point(0, 0, 0);
          fill(blue);

          float[] rotations = cam.getRotations();
          rotateX(rotations[0]);
          rotateY(rotations[1]);
          rotateZ(rotations[2]);

          textMode(SHAPE);
          textSize(3);
          n = users.get(i).botscore;
          s = users.get(i).m2-users.get(i).m1;
          y = users.get(i).date.toUpperCase();
          if (showDate == false) {
            if (showItem == false) {
              text(s, 0, 0);
            } else {
              text (n, 0, 0);
            }
          } else {
            text(y, 0, 0);
          }
        }
        popMatrix();
      }
      }
    
    if (SHOW6 == true) {
      if (users.get(i).topic==6) {
        drawCurve(dateAxis, date2Axis, timeAxis, m1Axis, m2Axis, c);
                float t_z = timeAxis;
        float t_x = (date2Axis - dateAxis) / 2.0 + dateAxis;
        float t_y = m2Axis-m1Axis;

        pushMatrix();
        translate(t_x, t_y, t_z);
        if (showMiddle == true) {
          strokeWeight(3);
          point(0, 0, 0);
          fill(pink);
        }

        float mouseObjectDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0));
        if (mouseObjectDistance < 30) {
          strokeWeight(10);
          point(0, 0, 0);
          fill(blue);

          float[] rotations = cam.getRotations();
          rotateX(rotations[0]);
          rotateY(rotations[1]);
          rotateZ(rotations[2]);

          textMode(SHAPE);
          textSize(3);
          n = users.get(i).botscore;
          s = users.get(i).m2-users.get(i).m1;
          y = users.get(i).date.toUpperCase();
          if (showDate == false) {
            if (showItem == false) {
              text(s, 0, 0);
            } else {
              text (n, 0, 0);
            }
          } else {
            text(y, 0, 0);
          }
        }
        popMatrix();
      }
      }
    
    if (SHOW7 == true) {
      if (users.get(i).topic==7) {
        drawCurve(dateAxis, date2Axis, timeAxis, m1Axis, m2Axis, c);
                float t_z = timeAxis;
        float t_x = (date2Axis - dateAxis) / 2.0 + dateAxis;
        float t_y = m2Axis-m1Axis;

        pushMatrix();
        translate(t_x, t_y, t_z);
        if (showMiddle == true) {
          strokeWeight(3);
          point(0, 0, 0);
          fill(pink);
        }

        float mouseObjectDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0));
        if (mouseObjectDistance < 30) {
          strokeWeight(10);
          point(0, 0, 0);
          fill(blue);

          float[] rotations = cam.getRotations();
          rotateX(rotations[0]);
          rotateY(rotations[1]);
          rotateZ(rotations[2]);

          textMode(SHAPE);
          textSize(3);
          n = users.get(i).botscore;
          s = users.get(i).m2-users.get(i).m1;
          y = users.get(i).date.toUpperCase();
          if (showDate == false) {
            if (showItem == false) {
              text(s, 0, 0);
            } else {
              text (n, 0, 0);
            }
          } else {
            text(y, 0, 0);
          }
        }
        popMatrix();
      }
    }
  }
}
