/*************************************************************************************
 Assignment 3 in course MAT259
 3D visualization - Social Dilemma & User Behaviors - Qing Huang
 
 Green: Negative
 Red: Positive
 
 Borrowed from Data Visualization - Basic 3D Demo
 Author: Rodger (Jieliang) Luo
 Supervisor: George Legradsy
 
 Borrowed from Data Visualization - PROJECT2
 Author: Yanchen Lu
 Supervisor: George Legradsy
 
 Purpose: Show how to present volume data in a basic 3D environment
 
 Usage: 1. A mouse left-drag will rotate the camera around the subject.
 2. A right drag will zoom in and out.
 3. A double-click restores the camera to its original position.
 4. rotation
 
 *************************************************************************************/
import controlP5.*;
import peasy.*;
PeasyCam cam;
ControlP5 cp5;


int numMiddlePoints = 5;
color green = #00BC56;
color pink = color(255, 102, 178);
color blue = color(153, 204, 255);

color c3 = color(51, 0, 102);
color c1 = color(209, 204, 255);

color c7 = color(0, 102, 204);
color c5 = color(153, 204, 255);

color c8 = color(102, 0, 51);
color c9 = color(255, 102, 178);

color lin = color(255, 255, 255);

float gray;
float fillColor;
boolean showPoint;
boolean showX;
boolean showY;
boolean showZ;
boolean SHOWRED = true;
boolean SHOWGREEN = true;
boolean SHOWNEUTRAL= true;
boolean SHOW3 = true;
boolean SHOW4 = true;
boolean SHOW5 = true;
boolean SHOW6 = true;
boolean SHOW7 = true;

boolean showDate = false;
boolean showItem = false;
int s;
String y;
float n;
boolean makeWeave = false;
boolean showMiddle = false;
boolean sentimentVStopic = true;

int startYear = 2006;
int endYear = 2022;

Table table;
int numRows, numColumns;

ArrayList<User> users = new ArrayList<User>();

void setup() {
  size(1000, 1000, P3D);
  cam = new PeasyCam(this, 400);

  //Added on Jan 30th by Rodger Luo
  float  cameraZ = (height/2.0) / tan(PI*60.0/360.0);
  perspective(PI/3.0, width/height, 0.001, cameraZ*10.0); //set near clip to 0.001 to go inside data
  //Finished adding

  table = loadTable("data-SD.csv", "header");
  numRows = table.getRowCount();
  println("Rows: " + numRows);

  for (int i=0; i<numRows; i++) {
    int ID = table.getInt(i, 0);
    String date= table.getString(i, 1);
    String time= table.getString(i, 2);
    float  botscore= table.getFloat(i, 3);
    int m1=table.getInt(i, 4);
    int m2=table.getInt(i, 5);
    int sentiment=table.getInt(i, 6);
    int topic=table.getInt(i, 7);
    users.add(new User(ID, date, time, botscore, m1, m2, sentiment, topic));
  }
  cp5 =new ControlP5(this);
  gray=128;
  showPoint = true;
  showX = true;
  showY = true;
  showZ = true;
  setGui();

  fillColor= 255;
}


void draw() {
  background(0);
  if (sentimentVStopic == true) {
    controlPanel1();
    SentimentGrouping (users);
  } else {
    controlPanel2();
    TopicGrouping(users);
  }

  drawLabels();
  fill(200, 20);
  noStroke();

  gui();
}



void drawLabels() {

  fill(255);
  textSize(30);
  pushMatrix();
  textAlign(LEFT, TOP);
  translate(-100, 0, 50);
  scale(0.2);
  text("Aug-10-2020", 0, 0, 0);
  popMatrix();
  
  pushMatrix();
  textAlign(RIGHT, TOP);
  translate(100, 0, 50);
  scale(0.2);
  text("Nov-8-2020", 0, 0, 0);
  popMatrix();

  pushMatrix();
  textAlign(LEFT, TOP);
  translate(80, -70, 0);
  scale(0.3);
  text("Monthly Posting Frequency Change", 0, 0, 0);
  popMatrix();



  pushMatrix();      
  textAlign(LEFT, CENTER);
  translate(100, 0, 50);
  scale(0.2);
  text("00:00", 0, 0, 0);
  popMatrix();

  pushMatrix();
  textAlign(LEFT, CENTER);
  translate(100, 0, -50);
  scale(0.2);
  text("23:59", 0, 0, 0);
  popMatrix();
}

void setGui() {
  PFont pfont=createFont("Arial", 16, true);
  ControlFont font = new ControlFont(pfont, 12);
  float X = 60;
  float distance = 800;
  int index = 0;

  cp5.addToggle("sentimentVStopic")
    .setCaptionLabel("TOPIC<->SENTIMENT")
    .setFont(font)
    .setColorActive(#808080)
    .setColorBackground(#fdf5e6)
    .setColorCaptionLabel(#fdf5e6)
    .setColorForeground(#fdf5e6)
    .setPosition (X, 100);

  cp5.addTextlabel("label0")
    .setFont(font)
    .setText("Press M: Control Middle Point")
    .setPosition(X, distance-20);

  cp5.addTextlabel("label1")
    .setFont(font)
    .setText("Press Space: Control Panel")
    .setPosition(X, distance);

  cp5.addTextlabel("label2")
    .setFont(font)
    .setText("Double Click: Original Position")
    .setPosition(X, distance+20);


  cp5.addTextlabel("label4")
    .setFont(font)
    .setText("Mouse Near Point: Show Change in Frequency")
    .setPosition(X, distance+60);

  cp5.addTextlabel("label5")
    .setFont(font)
    .setText("Press SHIFT: Show Posting Date Instead")
    .setPosition(X, distance+80);

  cp5.addTextlabel("label6")
    .setFont(font)
    .setText("Press CONTROL: Show Botscore Instead")
    .setPosition(X, distance+100);

  cp5.addBang("zoomIn")
    .setLabel("Zoom In")
    .setColorActive(color(#FF8C00))
    .setColorForeground(color(#FFA500))
    .setPosition(X, 160);

  cp5.addBang("zoomOut")
    .setLabel("Zoom Out")
    .setColorActive(color(#FF8C00))
    .setColorForeground(color(#FFA500))
    .setPosition(X + 50, 160);

  cp5.addTextlabel("rotate Y")
    .setText("Rotate along the y-axis")
    .setPosition(X, 210);


  cp5.addBang("rotY")
    .setLabel("CW")
    .setPosition(X, 230)
    .setColorActive(color(#40E0D0))
    .setColorForeground(color(#00CED1));

  cp5.addBang("rotYneg")
    .setLabel("CCW")
    .setPosition(X + 50, 230)
        .setColorActive(color(#40E0D0))
    .setColorForeground(color(#00CED1));

  cp5.addTextlabel("rotate X")
    .setText("Rotate along the x-axis")
    .setPosition(X, 270);

  cp5.addBang("rotXneg")
    .setLabel("CW")
    .setPosition(X, 290);
    

  cp5.addBang("rotX")
    .setLabel("CCW")
    .setPosition(X + 50, 290);

  cp5.setAutoDraw(false);
}

void randomizeColor() {
  gray = random(0, 255);
}

void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}


void drawCurve(float dateAxis, float date2Axis, float timeAxis, float m1Axis, float m2Axis, color cCurve) {

  strokeWeight(4);
  stroke(cCurve);

  float t_z = timeAxis;
  float t_x = (date2Axis - dateAxis) / 2.0 + dateAxis;
  float t_y = m2Axis-m1Axis;

  strokeWeight(2);
  stroke(color(cCurve, 95));

  noFill();
  beginShape();
  curveVertex(dateAxis, 0, timeAxis);
  curveVertex(dateAxis, 0, timeAxis);
  curveVertex(t_x, t_y, t_z);
  curveVertex(date2Axis, 0, timeAxis);
  curveVertex(date2Axis, 0, timeAxis);
  endShape();
}

void drawPoint(float dateAxis, float date2Axis, float timeAxis, color cCurve) {
  strokeWeight(4);
  stroke(cCurve);
  point(dateAxis, 0, timeAxis);
  point(date2Axis, 0, timeAxis);
}

void controlPanel1() {
  PFont pfont=createFont("Arial", 16, true);
  ControlFont font = new ControlFont(pfont, 12);
  float X = 60;
  float distance = 800;
  int index = 0;

  cp5.addToggle("SHOWGREEN")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(#00BC56)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#00BC56)
    .setColorForeground(#808080)
    .setPosition (X+800, 100);

  cp5.addToggle("SHOWRED")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(c9)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#F75F00)
    .setColorForeground(#808080)
    .setPosition (X+800, 119);

  cp5.addToggle("SHOWNEUTRAL")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(c5)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#F75F00)
    .setColorForeground(#808080)
    .setPosition (X+800, 138);

  cp5.addTextlabel("labelgreen")
    .setFont(font)
    .setText("negative")
    .setColor(#00BC56)
    .setPosition(X+840, 100);

  cp5.addTextlabel("labelred")
    .setFont(font)
    .setColor(c9)
    .setText("positive")
    .setPosition(X+840, 120);

  cp5.addTextlabel("labelneutral")
    .setFont(font)
    .setColor(c5)
    .setText("neutral")
    .setPosition(X+840, 140);
    
  X=X+500;
    
  cp5.addToggle("SHOW3")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(#a020f0)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#00BC56)
    .setColorForeground(#808080)
    .setPosition (X+800, 157);

  cp5.addToggle("SHOW4")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(#00ffff)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#F75F00)
    .setColorForeground(#808080)
    .setPosition (X+800, 176);

  cp5.addToggle("SHOW5")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(#ffff00)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#F75F00)
    .setColorForeground(#808080)
    .setPosition (X+800, 195);

  cp5.addToggle("SHOW6")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(#ff0000)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#00BC56)
    .setColorForeground(#808080)
    .setPosition (X+800, 214);

  cp5.addToggle("SHOW7")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(#008000)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#F75F00)
    .setColorForeground(#808080)
    .setPosition (X+800, 233);

  cp5.addTextlabel("labeltopic3")
    .setFont(font)
    .setColor(#a020f0)
    .setText("topic3")
    .setPosition(X+840, 160);

  cp5.addTextlabel("labeltopic4")
    .setFont(font)
    .setColor(#00ffff)
    .setText("topic4")
    .setPosition(X+840, 180);

  cp5.addTextlabel("labeltopic5")
    .setFont(font)
    .setColor(#ffff00)
    .setText("topic5")
    .setPosition(X+840, 199);

  cp5.addTextlabel("labeltopic6")
    .setFont(font)
    .setColor(#ff0000)
    .setText("topic6")
    .setPosition(X+840, 219);

  cp5.addTextlabel("labeltopic7")
    .setFont(font)
    .setColor(#008000)
    .setText("topic7")
    .setPosition(X+840, 237);
    
      cp5.addTextlabel("key0")
    .setFont(font)
    .setText("watch like know good")
    .setColor(#ff69b4)
    .setPosition(X+640, 100);

  cp5.addTextlabel("key1")
    .setFont(font)
    .setColor(#ffdead)
    .setText("people like think algorithm")
    .setPosition(X+640, 120);

  cp5.addTextlabel("key2")
    .setFont(font)
    .setColor(#1e90ff)
    .setText("Netflix watch official Trailer")
    .setPosition(X+640, 140);

  cp5.addTextlabel("key3")
    .setFont(font)
    .setColor(#a020f0)
    .setText("Twitter phone delete time")
    .setPosition(X+640, 160);
    
  cp5.addTextlabel("key4")
    .setFont(font)
    .setColor(#00ffff)
    .setText("news facebook fake")
    .setPosition(X+640, 180);

  cp5.addTextlabel("key5")
    .setFont(font)
    .setColor(#ffff00)
    .setText("recommend documentary")
    .setPosition(X+640, 199);

  cp5.addTextlabel("key6")
    .setFont(font)
    .setColor(#ff0000)
    .setText("tech society change")
    .setPosition(X+640, 219);

  cp5.addTextlabel("key7")
    .setFont(font)
    .setColor(#008000)
    .setText("product review pay")
    .setPosition(X+640, 237);
    
}

void controlPanel2() {
  PFont pfont=createFont("Arial", 16, true);
  ControlFont font = new ControlFont(pfont, 12);
  float X = 60;
  float distance = 800;
  int index = 0;

  cp5.addToggle("SHOWGREEN")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(#ff69b4)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#ff69b4)
    .setColorForeground(#808080)
    .setPosition (X+800, 100);

  cp5.addToggle("SHOWRED")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(#ffdead)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#F75F00)
    .setColorForeground(#808080)
    .setPosition (X+800, 119);

  cp5.addToggle("SHOWNEUTRAL")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(#1e90ff)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#1e90ff)
    .setColorForeground(#808080)
    .setPosition (X+800, 138);

  cp5.addToggle("SHOW3")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(#a020f0)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#00BC56)
    .setColorForeground(#808080)
    .setPosition (X+800, 157);

  cp5.addToggle("SHOW4")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(#00ffff)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#F75F00)
    .setColorForeground(#808080)
    .setPosition (X+800, 176);

  cp5.addToggle("SHOW5")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(#ffff00)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#F75F00)
    .setColorForeground(#808080)
    .setPosition (X+800, 195);

  cp5.addToggle("SHOW6")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(#ff0000)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#00BC56)
    .setColorForeground(#808080)
    .setPosition (X+800, 214);

  cp5.addToggle("SHOW7")
    .setCaptionLabel("")
    .setFont(font)
    .setColorActive(#008000)
    .setColorBackground(#808080)
    .setColorCaptionLabel(#F75F00)
    .setColorForeground(#808080)
    .setPosition (X+800, 233);

  cp5.addTextlabel("labelgreen")
    .setFont(font)
    .setText("topic0")
    .setColor(#ff69b4)
    .setPosition(X+840, 100);

  cp5.addTextlabel("labelred")
    .setFont(font)
    .setColor(#ffdead)
    .setText("topic1")
    .setPosition(X+840, 120);

  cp5.addTextlabel("labelneutral")
    .setFont(font)
    .setColor(#1e90ff)
    .setText("topic2")
    .setPosition(X+840, 140);

  cp5.addTextlabel("labeltopic3")
    .setFont(font)
    .setColor(#a020f0)
    .setText("topic3")
    .setPosition(X+840, 160);

  cp5.addTextlabel("labeltopic4")
    .setFont(font)
    .setColor(#00ffff)
    .setText("topic4")
    .setPosition(X+840, 180);

  cp5.addTextlabel("labeltopic5")
    .setFont(font)
    .setColor(#ffff00)
    .setText("topic5")
    .setPosition(X+840, 199);

  cp5.addTextlabel("labeltopic6")
    .setFont(font)
    .setColor(#ff0000)
    .setText("topic6")
    .setPosition(X+840, 219);

  cp5.addTextlabel("labeltopic7")
    .setFont(font)
    .setColor(#008000)
    .setText("topic7")
    .setPosition(X+840, 237);
    
    
    
    
  cp5.addTextlabel("key0")
    .setFont(font)
    .setText("watch like know good")
    .setColor(#ff69b4)
    .setPosition(X+640, 100);

  cp5.addTextlabel("key1")
    .setFont(font)
    .setColor(#ffdead)
    .setText("people like think algorithm")
    .setPosition(X+640, 120);

  cp5.addTextlabel("key2")
    .setFont(font)
    .setColor(#1e90ff)
    .setText("Netflix watch official Trailer")
    .setPosition(X+640, 140);

  cp5.addTextlabel("key3")
    .setFont(font)
    .setColor(#a020f0)
    .setText("Twitter phone delete time")
    .setPosition(X+640, 160);
    
  cp5.addTextlabel("key4")
    .setFont(font)
    .setColor(#00ffff)
    .setText("news facebook fake")
    .setPosition(X+640, 180);

  cp5.addTextlabel("key5")
    .setFont(font)
    .setColor(#ffff00)
    .setText("recommend documentary")
    .setPosition(X+640, 199);

  cp5.addTextlabel("key6")
    .setFont(font)
    .setColor(#ff0000)
    .setText("tech society change")
    .setPosition(X+640, 219);

  cp5.addTextlabel("key7")
    .setFont(font)
    .setColor(#008000)
    .setText("product review pay")
    .setPosition(X+640, 237);
}
